
clc
clear all
NOTCONVERGENCE=[];
NOTCONVERGENCEMAXLOAD=[];
NOTCONVERGENCEMAXSTRAIN=[];
    
USEDCRITERION=[];
for h=1:50
    %Selct files
    MATERIALNAME=sprintf('Materialparameter%d.txt', h-1);
    ANALYSISOUT=sprintf('Nonlinear_analysis%d.out',h-1);
    FILENAME=sprintf('Output%d.TB',h-1);
    
    %Import material parameteres from file
    FID=fopen(MATERIALNAME);
    TLINE=fgetl(FID);
    fcm=str2num(TLINE(1:7));
    TLINE=fgetl(FID);
    E=str2num(TLINE(1:8));
    TLINE=fgetl(FID);
    fym=str2num(TLINE(1:8));
    TLINE=fgetl(FID);
    fum=str2num(TLINE(1:8));
    fclose(FID);
    
    %Failure criterias
    FAILSTRAINCON=-0.0018;
    FAILSTRAINCONMAX=(-5/3)*fcm/E;
    
	%Parse convergence
    CONVERGENCE=[];
    FID = fopen(ANALYSISOUT);
    TLINE = fgetl(FID);
    while ischar(TLINE)
        STRING = 'RELATIVE OUT OF BALANCE';
        FOUND = strfind(TLINE,STRING);
        if size(FOUND)*size(FOUND)' > 0
            for k=1:3
                TLINE = fgetl(FID);
                length(TLINE);
                if k==2
                    if length(TLINE)==57
                        CONVERGENCE = [CONVERGENCE; str2num(TLINE(45:47))];
                    elseif length(TLINE)==58
                        CONVERGENCE = [CONVERGENCE; str2num(TLINE(45:47))];
                    elseif length(TLINE)==61
                        CONVERGENCE = [CONVERGENCE; str2num(TLINE(48:50))];
                    end
                end
            end
        end
        TLINE = fgetl(FID);
    end
    
    %Parse load factors
    LOAD=[];
    FID = fopen(FILENAME);
    TLINE = fgetl(FID);
    while ischar(TLINE)
        STRING = 'Step nr.';
        FOUND = strfind(TLINE,STRING);
        if size(FOUND)*size(FOUND)' > 0
            TLINE = fgetl(FID);
            LOAD = [LOAD; str2num(TLINE(24:32))];
        end
        TLINE = fgetl(FID);
    end
    
    %Remove redudant load factors
    LOADFINAL=[];
    LOADSTEPS=length(LOAD)/5;
    for i=1:LOADSTEPS
        k=5*i-1;
        LOADFINAL(i,1)=LOAD(k);
    end
    
    %Parse step numbers
    STEP=[];
    FID = fopen(FILENAME);
    TLINE = fgetl(FID);
    while ischar(TLINE)
        STRING = 'Analysis type';
        FOUND = strfind(TLINE,STRING);
        if size(FOUND)*size(FOUND)' > 0
            TLINE = fgetl(FID);
            STEP = [STEP; str2num(TLINE(24:25))];
        end
        TLINE = fgetl(FID);
    end
    
    STEPFINAL=[];
    %Remove redudant step
    for i=1:LOADSTEPS
        k=5*i-1;
        STEPFINAL(i,1)=STEP(k);
    end
    
	%Parse deflections
    DISP= [];
    FID = fopen(FILENAME);
    TLINE = fgetl(FID);
    while ischar(TLINE)
        STRING2 = 'Nodnr       TDtY ';
        FOUND2 = strfind(TLINE,STRING2);
        if size(FOUND2)*size(FOUND2)' > 0
            for k=1:2
                TLINE=fgetl(FID);
                if k==2
                    DISP=[DISP;str2num(TLINE(10:19))];
                end
            end
        end
        TLINE = fgetl(FID);
    end
    
    %Parse concrete strains
    %CONSTRAIN1 shows the strains in the integration points for the first
    %element listed. The columns are the 4 different integration points.
    CONSTRAIN=[];
    CONSTRAIN1=[];
    CONSTRAIN2=[];
    CONSTRAIN3=[];
    CONSTRAIN4=[];
    
    FID = fopen(FILENAME);
    TLINE = fgetl(FID);
    while ischar(TLINE)
        STRING = 'Elmnr Intpt        E1';
        FOUND = strfind(TLINE,STRING);
        if size(FOUND)*size(FOUND)' > 0
            for k=1:16
                TLINE=fgetl(FID);
                CONSTRAIN=[CONSTRAIN;str2num(TLINE(16:25)) str2num(TLINE(27:36)) str2num(TLINE(38:47))];
            end
        end
        TLINE = fgetl(FID);
    end
    for k=1:(LOADSTEPS-1)
        for m=1:4
            i=m+16*k;
            for j=1:3
                CONSTRAIN1(1,m,j)=CONSTRAIN(m,j);
                CONSTRAIN2(1,m,j)=CONSTRAIN(m+4,j);
                CONSTRAIN3(1,m,j)=CONSTRAIN(m+8,j);
                CONSTRAIN4(1,m,j)=CONSTRAIN(m+12,j);
                CONSTRAIN1(k+1,m,j)=CONSTRAIN(i,j);
                CONSTRAIN2(k+1,m,j)=CONSTRAIN(i+4,j);
                CONSTRAIN3(k+1,m,j)=CONSTRAIN(i+8,j);
                CONSTRAIN4(k+1,m,j)=CONSTRAIN(i+12,j);
            end
        end
    end
    
    CONSTRAINMIN1=[];
    CONSTRAINMIN2=[];
    CONSTRAINMIN3=[];
    CONSTRAINMIN4=[];
    
    for k=1:LOADSTEPS
        CONSTRAINMIN1=[CONSTRAINMIN1; min(CONSTRAIN1(k,:,:))];
        CONSTRAINMIN2=[CONSTRAINMIN2; min(CONSTRAIN2(k,:,:))];
        CONSTRAINMIN3=[CONSTRAINMIN3; min(CONSTRAIN3(k,:,:))];
        CONSTRAINMIN4=[CONSTRAINMIN4; min(CONSTRAIN4(k,:,:))];
        CONSTRAIN1MIN(k,1)=min(CONSTRAINMIN1(k,:,:));
        CONSTRAIN2MIN(k,1)=min(CONSTRAINMIN2(k,:,:));
        CONSTRAIN3MIN(k,1)=min(CONSTRAINMIN3(k,:,:));
        CONSTRAIN4MIN(k,1)=min(CONSTRAINMIN4(k,:,:));
    end
    CONSTRAINMIN=[CONSTRAIN1MIN CONSTRAIN2MIN CONSTRAIN3MIN CONSTRAIN4MIN];
    
    CONSTRAINMIN=[CONSTRAIN1MIN CONSTRAIN2MIN CONSTRAIN3MIN CONSTRAIN4MIN];
    for k=1:LOADSTEPS
        MINCONSTRAIN(k,1)=min(CONSTRAINMIN(k,:));
    end
    
    %A=[STEPFINAL,LOADFINAL,MINCONSTRAIN,CONVERGENCE];
    antall=0;
    antallmax=0;
    for i=1:LOADSTEPS
        if MINCONSTRAIN(i,1)<=FAILSTRAINCON
            antall=antall+1;
        else
            FAILURE(i,1)=0;
        end
        if MINCONSTRAIN(i,1)<=FAILSTRAINCONMAX
            antallmax=antallmax+1;
        end
        if antall==1
            FAILURESTEP=i-1;
        end
        if antallmax==1
            FAILURESTEPMAX=i-1;
        end
    end
    
	%Column number
    %1 = 1,8
    %2 = Max parabolic strain
    %3 = Maxload
    [FAMAXLOAD, FAMAXLOADSTEP]=max(LOADFINAL);
    FAMAXLOAD=FAMAXLOAD*100;
    if CONVERGENCE(FAMAXLOADSTEP)==100
        NOTCONVERGENCEMAXLOAD=[NOTCONVERGENCEMAXLOAD; h];
        FAMAXLOADCONVERGED=FAMAXLOAD;
        FAMAXLOADCONVERGEDSTEP=FAMAXLOADSTEP;
    else
        FAMAXLOADCONVERGEDSTEP=FAMAXLOADSTEP;
        FAMAXLOADCONVERGED=FAMAXLOAD;
    end
    while CONVERGENCE(FAMAXLOADCONVERGEDSTEP)==100
         FAMAXLOADCONVERGEDSTEP=FAMAXLOADCONVERGEDSTEP-1;
         FAMAXLOADCONVERGED=LOADFINAL(FAMAXLOADCONVERGEDSTEP)*100;
    end
    
    if min(MINCONSTRAIN)<= FAILSTRAINCON
        [FAILURELOAD, FAILUREUSEDSTEP]=max(LOADFINAL(1:FAILURESTEP));
        FAILURELOAD=FAILURELOAD*100;
        if CONVERGENCE(FAILUREUSEDSTEP)==100
            NOTCONVERGENCE=[NOTCONVERGENCE; h];
        end
        USEDCRITERION(h,1)=1;
    else
        [FAILURELOAD, FAILUREUSEDSTEP]=max(LOADFINAL);
        FAILURELOAD=FAILURELOAD*100;
        NOTCONVERGENCE=NOTCONVERGENCEMAXLOAD;
        USEDCRITERION(h,1)=3;
    end
    
    if min(MINCONSTRAIN)<=FAILSTRAINCONMAX
        FAILURELOADMAX=LOADFINAL(FAILURESTEPMAX)*100;
        if CONVERGENCE(FAILURESTEPMAX)==100
            NOTCONVERGENCEMAXSTRAIN=[NOTCONVERGENCEMAXSTRAIN; h];
        end
        USEDCRITERION(h,2)=2;
    else
        FAILURELOADMAX=max(LOADFINAL);
        FAILURELOADMAX=FAILURELOADMAX*100;
        NOTCONVERGENCEMAXSTRAIN=NOTCONVERGENCEMAXLOAD;
        USEDCRITERION(h,2)=3;
    end
    
    MATERIAL(h,1)=fcm;
    MATERIAL(h,2)=fym;
    CAPACITY(h,1)=FAILURELOAD;
    CAPACITY(h,2)=FAILURELOADMAX;
    CAPACITY(h,3)=FAMAXLOADCONVERGED;
    
    
    
%     fig=gcf;
%     set(findall(fig,'-property','FontSize'),'FontSize',24)
%     set(gca,'fontsize',12)
%     hold on
%     FIGNAME=sprintf('Plot%d', h-1);
%     figure('DefaultAxesFontSize',15)
%     DISPLOT=[0; DISP];
%     LOADPLOT=[0; LOADFINAL];
%     plot(-DISPLOT,LOADPLOT*100,'k');
%     xlabel('Deflection [mm]');
%     ylabel('Total load [kN]');
%     
%     axis([0 100 0 100]);
%     print(FIGNAME,'-dpng')
%     print(FIGNAME,'-dpdf')
    
    fclose(FID);
end
OUTPUT=[MATERIAL CAPACITY];

% x=[];
% y=[];
% for i=1:10
%     k=10*i-1;
%     x(1,i)=MATERIAL(k,1);
% end
% 
% for j=1:10
%     y(1,j)=MATERIAL(j,2);
% end
% 
% for i=1:10
%     for j=1:10
%         P(i,j)=CAPACITY(j+(i-1)*10,1);
%         P2(i,j)=CAPACITY(j+(i-1)*10,3);
%     end
% end
% figure(1)
% surf(y,x,P)
% xlabel('f_{sy} [MPa]');
% ylabel('f_{c, situ} [MPa]')
% zlabel('Capacity [kN]');
% axis([380 630 12.5 45  35 65]);
% view([-3 -1 2]);
% colormap(gray);
% print('RS','-dpng')
% print('RS','-dpdf')
% 
% plotcy1=P(1:10,1);
% plotcy2=P(1:10,5);
% plotcy3=P(1:10,10);
% plotx=x;
% 
% figure(2)
% plot(plotx,plotcy1,'-ok')
% hold on;
% plot(plotx,plotcy2,'-.ok')
% plot(plotx,plotcy3,'--ok')
% legend('f_{sy}=400.0000 MPa', 'f_{sy}=504.3560 MPa','f_{sy}=610.0000 MPa','Location','Northwest')
% xlabel('f_{c, situ} [MPa]');
% ylabel('Capacity [kN]');
% axis([min(plotx)-1 max(plotx)+1 35 70]);
% colormap(gray);
% print('RScon','-dpng')
% print('RScon','-dpdf')
% hold off;
% 
% 
% plotsy1=P(1,1:10);
% plotsy2=P(5,1:10);
% plotsy3=P(10,1:10);
% plots=y;
% 
% figure(3)
% plot(plots,plotsy1,'-ok')
% hold on;
% plot(plots,plotsy2,'-.ok')
% plot(plots,plotsy3,'--ok')
% legend('f_{c,situ}=15.0000 MPa','f_{c,situ}=26.0239 MPa','f_{c,situ}=42.5000 MPa','Location','Northwest')
% xlabel('f_{sy} [MPa]');
% ylabel('Capacity [kN]');
% axis([min(plots)-10 max(plots)+10 35 70]);
% colormap(gray);
% print('RSrei','-dpng')
% print('RSrei','-dpdf')
% hold off;